searchData={"content_type":"text/markdown","items":[{"doc":"Schema parser that gets Erl tuples (avro types) and transforms them into Elixir types.","ref":"ElixirAvro.AvroType.html","title":"ElixirAvro.AvroType","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.html#from_erl/1","title":"ElixirAvro.AvroType.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.html#c:from_erl/1","title":"ElixirAvro.AvroType.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.html#t:erlavro_type_name/0","title":"ElixirAvro.AvroType.erlavro_type_name/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.html#t:t/0","title":"ElixirAvro.AvroType.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.Array.html","title":"ElixirAvro.AvroType.Array","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.Array.html#from_erl/1","title":"ElixirAvro.AvroType.Array.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Array.html#c:from_erl/1","title":"ElixirAvro.AvroType.Array.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.Array.html#t:t/0","title":"ElixirAvro.AvroType.Array.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.CustomProp.html","title":"ElixirAvro.AvroType.CustomProp","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.CustomProp.html#from_erl/1","title":"ElixirAvro.AvroType.CustomProp.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.CustomProp.html#c:from_erl/1","title":"ElixirAvro.AvroType.CustomProp.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.CustomProp.html#logical_type?/1","title":"ElixirAvro.AvroType.CustomProp.logical_type?/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.CustomProp.html#t:t/0","title":"ElixirAvro.AvroType.CustomProp.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.Enum.html","title":"ElixirAvro.AvroType.Enum","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.Enum.html#from_erl/1","title":"ElixirAvro.AvroType.Enum.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Enum.html#c:from_erl/1","title":"ElixirAvro.AvroType.Enum.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.Enum.html#t:t/0","title":"ElixirAvro.AvroType.Enum.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.Fixed.html","title":"ElixirAvro.AvroType.Fixed","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.Fixed.html#from_erl/1","title":"ElixirAvro.AvroType.Fixed.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Fixed.html#c:from_erl/1","title":"ElixirAvro.AvroType.Fixed.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.Fixed.html#t:t/0","title":"ElixirAvro.AvroType.Fixed.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.Map.html","title":"ElixirAvro.AvroType.Map","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.Map.html#from_erl/1","title":"ElixirAvro.AvroType.Map.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Map.html#c:from_erl/1","title":"ElixirAvro.AvroType.Map.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.Map.html#t:t/0","title":"ElixirAvro.AvroType.Map.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.Primitive.html","title":"ElixirAvro.AvroType.Primitive","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.Primitive.html#from_erl/1","title":"ElixirAvro.AvroType.Primitive.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Primitive.html#c:from_erl/1","title":"ElixirAvro.AvroType.Primitive.from_erl/1","type":"callback"},{"doc":"Returns the logical type or nil if the primitive type isn't a logical type.","ref":"ElixirAvro.AvroType.Primitive.html#get_logical_type/1","title":"ElixirAvro.AvroType.Primitive.get_logical_type/1","type":"function"},{"doc":"Validate the given value against the provided Avro type.\n\n# Examples\n\nNOTE: put here all the examples.","ref":"ElixirAvro.AvroType.Primitive.html#validate/2","title":"ElixirAvro.AvroType.Primitive.validate/2","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Primitive.html#t:t/0","title":"ElixirAvro.AvroType.Primitive.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.Record.html","title":"ElixirAvro.AvroType.Record","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.Record.html#from_erl/1","title":"ElixirAvro.AvroType.Record.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Record.html#c:from_erl/1","title":"ElixirAvro.AvroType.Record.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.Record.html#t:t/0","title":"ElixirAvro.AvroType.Record.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.RecordField.html","title":"ElixirAvro.AvroType.RecordField","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.RecordField.html#from_erl/1","title":"ElixirAvro.AvroType.RecordField.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.RecordField.html#c:from_erl/1","title":"ElixirAvro.AvroType.RecordField.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.RecordField.html#t:t/0","title":"ElixirAvro.AvroType.RecordField.t/0","type":"type"},{"doc":"","ref":"ElixirAvro.AvroType.Union.html","title":"ElixirAvro.AvroType.Union","type":"behaviour"},{"doc":"","ref":"ElixirAvro.AvroType.Union.html#from_erl/1","title":"ElixirAvro.AvroType.Union.from_erl/1","type":"function"},{"doc":"","ref":"ElixirAvro.AvroType.Union.html#c:from_erl/1","title":"ElixirAvro.AvroType.Union.from_erl/1","type":"callback"},{"doc":"","ref":"ElixirAvro.AvroType.Union.html#t:t/0","title":"ElixirAvro.AvroType.Union.t/0","type":"type"},{"doc":"Module responsible for decoding values from Avro type definition.","ref":"ElixirAvro.AvroType.Value.Decoder.html","title":"ElixirAvro.AvroType.Value.Decoder","type":"module"},{"doc":"Decodes any avro value into its elixir format; raise if an error occurs.\n\n# Examples","ref":"ElixirAvro.AvroType.Value.Decoder.html#decode_value!/3","title":"ElixirAvro.AvroType.Value.Decoder.decode_value!/3","type":"function"},{"doc":"iex> decode_value!(nil, %Primitive{name: \"null\"}, \"\")\nnil\n\niex> decode_value!(true, %Primitive{name: \"boolean\"}, \"\")\ntrue\n\niex> decode_value!(25, %Primitive{name: \"int\"}, \"\")\n25\n\niex> decode_value!(2_147_483_648, %Primitive{name: \"int\"}, \"\")\n** (ArgumentError) decoding error: value out of range\n\niex> decode_value!(19723, %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}, \"\")\n~D[2024-01-01]\n\niex> decode_value!(3661123, %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-millis\"}]}, \"\")\n~T[01:01:01.123]\n\niex> decode_value!(202.35, %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}, \"\")\n** (ArgumentError) decoding error: not an integer value\n\niex> decode_value!(25699000123, %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-micros\"}]}, \"\")\n~T[07:08:19.000123]\n\niex> decode_value!(1704070923000, %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"timestamp-millis\"}]}, \"\")\n~U[2024-01-01 01:02:03.000Z]\n\niex> decode_value!(1263423607005000, %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"local-timestamp-micros\"}]}, \"\")\n~N[2010-01-13 23:00:07.005000]\n\niex> decode_value!(\"2024-01-13 11:00:03.123\", %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"timestamp-micros\"}]}, \"\")\n** (ArgumentError) decoding error: not an integer value\n\niex> decode_value!(\"67caff17-798d-4b70-b9d0-781d27382fdc\", %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}, \"\")\n\"67caff17-798d-4b70-b9d0-781d27382fdc\"\n\niex> decode_value!(\"not-a-uuid\", %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}, \"\")\n** (ArgumentError) decoding error: not a uuid value","ref":"ElixirAvro.AvroType.Value.Decoder.html#decode_value!/3-primitive-types","title":"Primitive types - ElixirAvro.AvroType.Value.Decoder.decode_value!/3","type":"function"},{"doc":"iex> decode_value!([\"one\", \"two\"], %Array{type:  %Primitive{name: \"string\"}}, \"\")\n[\"one\", \"two\"]\n\niex> decode_value!([\"one\", 2], %Array{type:  %Primitive{name: \"string\"}}, \"\")\n** (ArgumentError) decoding error: not a string value","ref":"ElixirAvro.AvroType.Value.Decoder.html#decode_value!/3-array-types","title":"Array types - ElixirAvro.AvroType.Value.Decoder.decode_value!/3","type":"function"},{"doc":"iex> decode_value!(%{\"one\" => 1, \"two\" => 2}, %Map{type: %Primitive{name: \"int\"}}, \"\")\n%{\"one\" => 1, \"two\" => 2}\n\niex> decode_value!(%{\"one\" => 1, \"two\" => \"2\"},  %Map{type: %Primitive{name: \"int\"}}, \"\")\n** (ArgumentError) decoding error: not an integer value","ref":"ElixirAvro.AvroType.Value.Decoder.html#decode_value!/3-map-types","title":"Map types - ElixirAvro.AvroType.Value.Decoder.decode_value!/3","type":"function"},{"doc":"iex> decode_value!(\n...>  nil,\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}\n...>  }}, \"\")\nnil\n\niex> decode_value!(\n...>  \"d8d8d536-700d-4773-a950-90fdcd3ae686\",\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}\n...>  }}, \"\")\n\"d8d8d536-700d-4773-a950-90fdcd3ae686\"\n\niex> decode_value!(\n...>  \"not-a-uuid-or-nil\",\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}\n...>  }}, \"\")\n** (ArgumentError) decoding error: no compatible type found","ref":"ElixirAvro.AvroType.Value.Decoder.html#decode_value!/3-union-types","title":"Union types - ElixirAvro.AvroType.Value.Decoder.decode_value!/3","type":"function"},{"doc":"Encodes a value according to the provided Avro type.","ref":"ElixirAvro.AvroType.Value.Encoder.html","title":"ElixirAvro.AvroType.Value.Encoder","type":"module"},{"doc":"Encodes any value into an avro compatible format.\n\n# Examples","ref":"ElixirAvro.AvroType.Value.Encoder.html#encode_value!/3","title":"ElixirAvro.AvroType.Value.Encoder.encode_value!/3","type":"function"},{"doc":"iex> encode_value!(true, %Primitive{name: \"boolean\"}, \"\")\ntrue\n\niex> encode_value!(25, %Primitive{name: \"int\"}, \"\")\n25\n\niex> encode_value!(2_147_483_648, %Primitive{name: \"int\"}, \"\")\n** (ArgumentError) encode error: value out of range\n\niex> encode_value!(~D[2024-01-01], %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}, \"\")\n19723\n\niex> encode_value!(~T[01:01:01.123], %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-millis\"}]}, \"\")\n3661123\n\niex> encode_value!(~T[04:05:06.001002], %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}, \"\")\n** (ArgumentError) encode error: not a date value\n\niex> encode_value!(~T[07:08:19.000123], %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-micros\"}]}, \"\")\n25699000123\n\niex> encode_value!(~U[2024-01-01 01:02:03.000Z], %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"timestamp-millis\"}]}, \"\")\n1704070923000\n\niex> encode_value!(~N[2010-01-13 23:00:07.005], %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"local-timestamp-micros\"}]}, \"\")\n1263423607005000\n\niex> encode_value!(~N[2024-01-13 11:00:03.123], %Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"timestamp-micros\"}]}, \"\")\n** (ArgumentError) encode error: not a datetime value\n\niex> encode_value!(\"67caff17-798d-4b70-b9d0-781d27382fdc\", %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}, \"\")\n\"67caff17-798d-4b70-b9d0-781d27382fdc\"\n\niex> encode_value!(\"not-a-uuid\", %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}, \"\")\n** (ArgumentError) encode error: not a uuid value","ref":"ElixirAvro.AvroType.Value.Encoder.html#encode_value!/3-primitive-types","title":"Primitive types - ElixirAvro.AvroType.Value.Encoder.encode_value!/3","type":"function"},{"doc":"iex> encode_value!([\"one\", \"two\"], %Array{type: %Primitive{name: \"string\"}}, \"\")\n[\"one\", \"two\"]\n\niex> encode_value!([\"one\", 2], %Array{type: %Primitive{name: \"string\"}}, \"\")\n** (ArgumentError) encode error: not a string value","ref":"ElixirAvro.AvroType.Value.Encoder.html#encode_value!/3-array-types","title":"Array types - ElixirAvro.AvroType.Value.Encoder.encode_value!/3","type":"function"},{"doc":"iex> encode_value!(%{\"one\" => 1, \"two\" => 2}, %Map{type: %Primitive{name: \"int\"}}, \"\")\n%{\"one\" => 1, \"two\" => 2}\n\niex> encode_value!(%{\"one\" => 1, \"two\" => \"2\"}, %Map{type: %Primitive{name: \"int\"}}, \"\")\n** (ArgumentError) encode error: not an integer value","ref":"ElixirAvro.AvroType.Value.Encoder.html#encode_value!/3-map-types","title":"Map types - ElixirAvro.AvroType.Value.Encoder.encode_value!/3","type":"function"},{"doc":"iex> encode_value!(\n...>  nil,\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}\n...>  }}, \"\")\nnil\n\niex> encode_value!(\n...>  \"d8d8d536-700d-4773-a950-90fdcd3ae686\",\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}\n...>  }}, \"\")\n\"d8d8d536-700d-4773-a950-90fdcd3ae686\"\n\niex> encode_value!(\n...>  \"not-a-uuid-or-nil\",\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}\n...>  }}, \"\")\n** (ArgumentError) encode error: no compatible type found","ref":"ElixirAvro.AvroType.Value.Encoder.html#encode_value!/3-union-types","title":"Union types - ElixirAvro.AvroType.Value.Encoder.encode_value!/3","type":"function"},{"doc":"iex> (fn ->\n...>   Code.eval_string(\"defmodule MyPrefix.TestType do\n...>     def to_avro(value), do: {:ok, value}\n...>   end\")\n...>   encode_value!(\"value\", \"TestType\", \"Elixir.MyPrefix\")\n...> end).()\n\"value\"\n\niex> encode_value!(%{}, \"TestUnknownType\", \"Elixir\")\n** (ArgumentError) encode error: unknown reference: TestUnknownType","ref":"ElixirAvro.AvroType.Value.Encoder.html#encode_value!/3-reference-types","title":"Reference types - ElixirAvro.AvroType.Value.Encoder.encode_value!/3","type":"function"},{"doc":"Module responsible for generating elixir modules (enums and structs) from Avro schemas.","ref":"ElixirAvro.Codegen.html","title":"ElixirAvro.Codegen","type":"module"},{"doc":"","ref":"ElixirAvro.Codegen.html#log/2","title":"ElixirAvro.Codegen.log/2","type":"function"},{"doc":"","ref":"ElixirAvro.Codegen.html#run/1","title":"ElixirAvro.Codegen.run/1","type":"function"},{"doc":"","ref":"ElixirAvro.Codegen.html#t:args/0","title":"ElixirAvro.Codegen.args/0","type":"type"},{"doc":"In the client module we expected a module attribute @values that contains a list of strings.\n\nThis macro will be used by the generated code, when enums, to create convenient function to access the enum variants.","ref":"ElixirAvro.Macro.ElixirEnum.html","title":"ElixirAvro.Macro.ElixirEnum","type":"module"},{"doc":"Schema resolver that uses erlavro and ets to resolve reference types.","ref":"ElixirAvro.Schema.Resolver.html","title":"ElixirAvro.Schema.Resolver","type":"module"},{"doc":"","ref":"ElixirAvro.Schema.Resolver.html#resolve_reference/2","title":"ElixirAvro.Schema.Resolver.resolve_reference/2","type":"function"},{"doc":"","ref":"ElixirAvro.Schema.Resolver.html#resolve_types/2","title":"ElixirAvro.Schema.Resolver.resolve_types/2","type":"function"},{"doc":"","ref":"ElixirAvro.Schema.Resolver.html#t:opts/0","title":"ElixirAvro.Schema.Resolver.opts/0","type":"type"},{"doc":"Module responsible for processing templates.","ref":"ElixirAvro.Template.html","title":"ElixirAvro.Template","type":"module"},{"doc":"","ref":"ElixirAvro.Template.html#eval!/2","title":"ElixirAvro.Template.eval!/2","type":"function"},{"doc":"Evaluates the all types applying the given template.\n\n# Examples\n\nNOTE: put here all the examples.","ref":"ElixirAvro.Template.html#eval_all!/2","title":"ElixirAvro.Template.eval_all!/2","type":"function"},{"doc":"","ref":"ElixirAvro.Template.html#t:t/0","title":"ElixirAvro.Template.t/0","type":"type"},{"doc":"Utility for elixir module names.","ref":"ElixirAvro.Template.Names.html","title":"ElixirAvro.Template.Names","type":"module"},{"doc":"","ref":"ElixirAvro.Template.Names.html#camelize/1","title":"ElixirAvro.Template.Names.camelize/1","type":"function"},{"doc":"","ref":"ElixirAvro.Template.Names.html#module_name!/2","title":"ElixirAvro.Template.Names.module_name!/2","type":"function"},{"doc":"Module responsible for processing field templates.","ref":"ElixirAvro.Template.Renderer.html","title":"ElixirAvro.Template.Renderer","type":"module"},{"doc":"","ref":"ElixirAvro.Template.Renderer.html#args_for_from_avro/1","title":"ElixirAvro.Template.Renderer.args_for_from_avro/1","type":"function"},{"doc":"Renders the @expected_keys module attribute for the given fields.","ref":"ElixirAvro.Template.Renderer.html#expected_keys/1","title":"ElixirAvro.Template.Renderer.expected_keys/1","type":"function"},{"doc":"","ref":"ElixirAvro.Template.Renderer.html#fields_for_from_avro/1","title":"ElixirAvro.Template.Renderer.fields_for_from_avro/1","type":"function"},{"doc":"","ref":"ElixirAvro.Template.Renderer.html#fields_for_to_avro/1","title":"ElixirAvro.Template.Renderer.fields_for_to_avro/1","type":"function"},{"doc":"Renders the @moduledoc documentation for the given fields.","ref":"ElixirAvro.Template.Renderer.html#module_doc/1","title":"ElixirAvro.Template.Renderer.module_doc/1","type":"function"},{"doc":"Renders the typestruct fields with their specs.","ref":"ElixirAvro.Template.Renderer.html#typedstruct_fields/1","title":"ElixirAvro.Template.Renderer.typedstruct_fields/1","type":"function"},{"doc":"Renders the @values for enum types.","ref":"ElixirAvro.Template.Renderer.html#values/1","title":"ElixirAvro.Template.Renderer.values/1","type":"function"},{"doc":"Module responsible for generating typespecs from Avro type.","ref":"ElixirAvro.Template.Spec.html","title":"ElixirAvro.Template.Spec","type":"module"},{"doc":"Decides whether to enforce typedstruct types or not based on which avro type is being used.","ref":"ElixirAvro.Template.Spec.html#enforce?/1","title":"ElixirAvro.Template.Spec.enforce?/1","type":"function"},{"doc":"Returns the string to be used as elixir type for any avro type.\n\n# Examples","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2","title":"ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"iex> to_typedstruct_spec!(%Primitive{name: \"boolean\"}, \"my_prefix\")\n\"boolean()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"bytes\"}, \"my_prefix\")\n\"binary()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"double\"}, \"my_prefix\")\n\"float()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"float\"}, \"my_prefix\")\n\"float()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"int\"}, \"my_prefix\")\n\"integer()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"long\"}, \"my_prefix\")\n\"integer()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"null\"}, \"my_prefix\")\n\"nil\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"string\"}, \"my_prefix\")\n\"String.t()\"\n\nAn unknown type will raise an ArgumentError:\n\niex> to_typedstruct_spec!(%Primitive{name: \"non-existent-type\"}, \"my_prefix\")\n** (ArgumentError) unsupported type: \"non-existent-type\"","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2-primitive-types","title":"Primitive types - ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"iex> to_typedstruct_spec!(%Primitive{name: \"bytes\", custom_props: [\n...>    %CustomProp{name: \"logicalType\", value: \"decimal\"}, %CustomProp{name: \"precision\", value: 4}, %CustomProp{name: \"scale\", value: 2}\n...>  ]},\n...>  \"my_prefix\")\n\"Decimal.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"uuid\"}]}, \"my_prefix\")\n\"String.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}, \"my_prefix\")\n\"Date.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-millis\"}]}, \"my_prefix\")\n\"Time.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-micros\"}]}, \"my_prefix\")\n\"Time.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"timestamp-millis\"}]}, \"my_prefix\")\n\"DateTime.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"timestamp-micros\"}]}, \"my_prefix\")\n\"DateTime.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"local-timestamp-millis\"}]}, \"my_prefix\")\n\"NaiveDateTime.t()\"\n\niex> to_typedstruct_spec!(%Primitive{name: \"long\", custom_props: [%CustomProp{name: \"logicalType\", value: \"local-timestamp-micros\"}]}, \"my_prefix\")\n\"NaiveDateTime.t()\"\n\nAn unknown logical type or a non-existent {primitive, logical} type combination will raise an ArgumentError:\n\niex> to_typedstruct_spec!(%Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"unsupported-logical-type\"}]}, \"my_prefix\")\n** (ArgumentError) unsupported type: {\"int\", \"unsupported-logical-type\"}\n\niex> to_typedstruct_spec!(%Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"timestamp-millis\"}]}, \"my_prefix\")\n** (ArgumentError) unsupported type: {\"string\", \"timestamp-millis\"}","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2-logical-types","title":"Logical types - ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"iex> to_typedstruct_spec!(%Fixed{name: \"md5\", namespace: \"test\", aliases: [], size: 16, fullname: \"test.md5\"}, \"my_prefix\")\n\"<<_::128>>\"","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2-fixed-types","title":"Fixed types - ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"iex> to_typedstruct_spec!(%Array{type: %Primitive{name: \"string\"}}, \"my_prefix\")\n\"[String.t()]\"\n\niex> to_typedstruct_spec!(%Array{type: %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}}, \"my_prefix\")\n\"[Date.t()]\"\n\nPrimitive types error logic still applies:\n\niex> to_typedstruct_spec!(%Array{type: %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}}, \"my_prefix\")\n** (ArgumentError) unsupported type: {\"string\", \"date\"}","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2-array-types","title":"Array types - ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"iex> to_typedstruct_spec!(%Map{type: %Primitive{name: \"int\"}}, \"my_prefix\")\n\"%{String.t() => integer()}\"\n\niex> to_typedstruct_spec!(%Map{type: %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-millis\"}]}}, \"my_prefix\")\n\"%{String.t() => Time.t()}\"\n\nPrimitive types error logic still applies:\n\niex> to_typedstruct_spec!(%Map{type: %Primitive{name: \"string\", custom_props: [%CustomProp{name: \"logicalType\", value: \"date\"}]}}, \"my_prefix\")\n** (ArgumentError) unsupported type: {\"string\", \"date\"}","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2-map-types","title":"Map types - ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"iex> to_typedstruct_spec!(\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"string\"}\n...>  }}, \"my_prefix\")\n\"nil | String.t()\"\n\niex> to_typedstruct_spec!(\n...>  %Union{values: %{\n...>    0 => %Primitive{name: \"null\"},\n...>    1 => %Primitive{name: \"int\", custom_props: [%CustomProp{name: \"logicalType\", value: \"time-millis\"}]}\n...>  }}, \"my_prefix\")\n\"nil | Time.t()\"","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2-union-types","title":"Union types - ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"iex> to_typedstruct_spec!(\"test.Type\", \"my_prefix\")\n\"MyPrefix.Test.Type.t()\"","ref":"ElixirAvro.Template.Spec.html#to_typedstruct_spec!/2-references","title":"References - ElixirAvro.Template.Spec.to_typedstruct_spec!/2","type":"function"},{"doc":"Mix compiler to allow mix to compile Avro source files into Elixir modules.\n\nLooks for `elixir_avro_codegen` key in your mix project config\n\n    def project do\n      [\n        # ...\n        elixir_avro_codegen: [\n          schema_path: \"avro\",\n          target_path: \"avro\",\n          prefix: \"MyApp.Avro\",\n          verbose: true\n        ],\n        compilers: Mix.compilers() ++ [:elixir_avro_codegen],\n        # ...\n      ]\n    end\n\nRequired options are:\n*  __schema_path__: The path to the directory containing the Avro schema files.\n* __target_path__:  The path to the directory where the generated Elixir code will be saved.\n* __prefix__:       The prefix to be used for the generated Elixir modules.\n\nOptional options are:\n* __verbose__: Enable verbose output. Defaults to `false`.","ref":"Mix.Tasks.Compile.ElixirAvroCodegen.html","title":"mix compile.elixir_avro_codegen","type":"task"},{"doc":"","ref":"Mix.Tasks.Compile.ElixirAvroCodegen.html#run/1","title":"Mix.Tasks.Compile.ElixirAvroCodegen.run/1","type":"function"},{"doc":"Mix task to generate elixir modules (enums and structs) that map avro schemas.\n\n# Usage\n\nThis mix task could be run using:\n\n```shell\nmix elixir_avro_codegen -t   -s   -p   [-v]\n```","ref":"Mix.Tasks.ElixirAvroCodegen.html","title":"mix elixir_avro_codegen","type":"task"},{"doc":"# The MIT License (MIT)\n\nCopyright (c) 2020 Prima.it\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"# elixir-avro\n\n`elixir-avro` is a library designed to facilitate the conversion of Avro schemas into Elixir code. \nThis library bridges the gap between Avro schema definitions and Elixir code, enabling seamless integration of \nAvro-defined data structures into Elixir projects.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `elixir_avro` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:elixir_avro, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation","title":"Installation - Overview","type":"extras"},{"doc":"Run this command to generate Elixir code from Avro schema files:\n\n```shell\n\n```\n\nThis will generate Elixir code for the Avro schema files in the `avro` directory, one for each Avro type defined in the schemas.","ref":"readme.html#usage","title":"Usage - Overview","type":"extras"},{"doc":"Given the following Avro schema definition in `avro/user.avsc`:\n\n```json\n{\n  \"name\": \"User\",\n  \"namespace\": \"registry\",\n  \"fullname\": \"registry.User\",\n  \"doc\": \"User registry information\",\n  \"type\": \"record\",\n  \"fields\": [\n    {\n      \"name\": \"firstname\",\n      \"type\": \"string\"\n    },\n    {\n      \"name\": \"lastname\",\n      \"type\": \"string\"\n    },\n    {\n      \"name\": \"age\",\n      \"type\": \"int\"\n    },\n    {\n      \"name\": \"role\",\n      \"type\": {\n        \"type\": \"enum\",\n        \"name\": \"Role\",\n        \"doc\": \"User's role.\",\n        \"fullname\": \"registry.user.Role\",\n        \"namespace\": \"registry.user\",\n        \"symbols\": [\n          \"ADMIN\",\n          \"USER\"\n        ]\n      }\n    }\n  ]\n}\n```\n\nRunning the following command:\n\n```shell\nmix elixir_avro_codegen --schemas-path avro/ --target-path lib --prefix MyApp.Avro\n```\n\nWill generate the following Elixir code in `lib/`:\n\n```elixir\n# lib/my_app/avro/registry/user.ex\ndefmodule MyApp.Avro.Registry.User do\n  @moduledoc \"\"\"\n  DO NOT EDIT MANUALLY: This module was automatically generated from an AVRO schema.\n\n  #","ref":"readme.html#example","title":"Example - Overview","type":"extras"},{"doc":"User registry information\n\n  #","ref":"readme.html#description","title":"Description - Overview","type":"extras"},{"doc":"- __fullname__: User's full name\n  - __role__: User's role.\n  \"\"\"\n\n  use TypedStruct\n\n  alias ElixirAvro.AvroType.Value.Decoder\n  alias ElixirAvro.AvroType.Value.Encoder\n\n  @expected_keys MapSet.new([\"fullname\", \"role\"])\n\n  typedstruct do\n    field :fullname, String.t(), enforce: true\n    field :role, MyApp.Avro.Registry.User.Role.t(), enforce: true\n  end\n\n  @module_prefix MyApp.Avro\n\n  def to_avro(%__MODULE__{} = struct) do\n    {:ok,\n     %{\n      # ...\n     }}\n  end\n\n  def from_avro(%{\"fullname\" => fullname, \"role\" => role}) do\n    {:ok,\n     %__MODULE__{\n      # ...\n     }}\n  rescue\n    e -> {:error, inspect(e)}\n  end\n\n  # ...\nend\n```\n\n```elixir\n# lib/my_app/avro/registry/user/role.ex\ndefmodule MyApp.Avro.Registry.User.Role do\n  @moduledoc \"\"\"\n  DO NOT EDIT MANUALLY: This module was automatically generated from an AVRO schema.\n\n  #","ref":"readme.html#fields","title":"Fields - Overview","type":"extras"},{"doc":"User's role.\n\n  \"\"\"\n\n  use ElixirAvro.Macro.ElixirEnum\n\n  @values [\"ADMIN\", \"USER\"]\n\n  def to_avro(value) do\n    {:ok, to_avro_string(value)}\n  rescue\n    _ -> {:error, :invalid_enum_value}\n  end\n\n  def from_avro(value) do\n    {:ok, from_avro_string(value)}\n  rescue\n    _ -> {:error, :invalid_enum_string_value}\n  end\nend\n```\n\nThe generated path is a concatenation of the `--prefix` option (snake-cased) and the Avro schema type's namespace.","ref":"readme.html#description","title":"Description - Overview","type":"extras"},{"doc":"```\nUsage: mix elixir_avro_codegen <-s directory> <-t directory> <-p name> [-v]\n-s, --schemas-path      The path to the directory containing the Avro schema files.\n-t, --target-path       The path to the directory where the generated Elixir code will be saved.\n-p, --prefix                 The prefix to be used for the generated Elixir modules.\n-v, --verbose                     Enable verbose output.\n```","ref":"readme.html#cli-options","title":"CLI Options - Overview","type":"extras"},{"doc":"In your mix.exs file, in `project` function, add the following configuration:\n\n```elixir\n  def project do\n    [\n      # ...\n      elixir_avro_codegen: [\n        schema_path: \"avro\",\n        target_path: \"avro\",\n        prefix: \"MyApp.Avro\"\n      ],\n      compilers: Mix.compilers() ++ [:elixir_avro_codegen],\n      # ...\n    ]\n  end\n```\n\nThe parameters used in the `elixir_avro_codegen` configuration are the same as the CLI options.","ref":"readme.html#compile-time-generation","title":"Compile-time generation - Overview","type":"extras"},{"doc":"#","ref":"readme.html#license","title":"License - Overview","type":"extras"},{"doc":"Copyright (c) 2020 Prima.it\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"readme.html#the-mit-license-mit","title":"The MIT License (MIT) - Overview","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}